// _________ .__                         _________                __                  __
// \_   ___ \|  | _____    ______ ______ \_   ___ \  ____   _____/  |_  ____ ___  ___/  |_
// /    \  \/|  | \__  \  /  ___//  ___/ /    \  \/ /  _ \ /    \   ___/ __ \\  \/  \   __\
// \     \___|  |__/ __ \_\___ \ \___ \  \     \___(  <_> |   |  |  | \  ___/ >    < |  |
//  \______  |____(____  /____  /____  >  \______  /\____/|___|  |__|  \___  /__/\_ \|__|
//         \/          \/     \/     \/          \/            \/          \/      \/
package Entity;

import java.util.*;

import Enum.CapaciteSpeciale;
import Enum.TypeMechant;
// Création de la classe Context qui permet de faire fonctionner le jeu
public class Context {
    // Création du jeu
    public static void CreationJeu(){
        System.out.println("Création du jeu");
        // Création de toutes les variables
        Context context = new Context();

        List<Carte> cartes = context.CreationCartes();
        Carte carteChoisie = context.ChoixCarte(cartes);
        MyLogger.getInstance().log("Carte Choisie : "+carteChoisie.getNom());
        List<Gentil> gentils = context.CreationGentils();
        Gentil gentilChoisi = context.ChoixGentil(gentils);
        MyLogger.getInstance().log("Gentil Choisi : "+gentilChoisi.getNom());

        List<Mechant> mechants = context.CreationMechants();
        Personnage[] tableau = new Personnage[carteChoisie.getLongueur()];
        // Création du tableau de jeu avec la carte choisie, le gentil choisi et une sélection aléatoire de méchant
        Jeu jeu = new Jeu(carteChoisie, gentilChoisi, mechants, tableau);
        tableau = RemplirTableau(tableau, gentilChoisi, mechants);
        MyLogger.getInstance().log(context.toStringTableau(tableau));

        System.out.println(
                "\n\nGentil choisi : " + gentilChoisi.getNom()+
                "\nCarte choisie : " + carteChoisie.getNom() +
                "\nVoici l'état initial du jeu : ");
        context.AfficheTableau(tableau);

        // Condition pour continuer le jeu / lancer un tour
        while(gentilChoisi.getIsAlive()){
            context.LancementTour(tableau, gentilChoisi, context);
            if (tableau[tableau.length - 1] == gentilChoisi) { // Si le gentil atteint la dernière case du tableau alors il a gagné
                System.out.println("Bravo !! Vous avez gagné la partie !!");
                MyLogger.getInstance().log("Partie Gagné !!");
                break;
            }
        }
        if (!gentilChoisi.getIsAlive()){
            System.out.println("Game Over, t'es trop nul, t'as perdu !!!");
            MyLogger.getInstance().log("Partie Perdue !!");
        }
    }
    // Remplissage du tableau de jeu
    public static Personnage[] RemplirTableau(Personnage[] tableau, Gentil gentilChoisi, List<Mechant> mechants){
        for(int i = 0; i < tableau.length ; i++){
            if (i == 0){ // On place toujours le gentil sur la permière case du tableau
                tableau[i] = gentilChoisi;
            } else if (i == tableau.length - 2) { // On place toujours un Boss sur l'avant dernière case du tableau
                tableau[i] = mechants.get(4);
            } else if(i == tableau.length - 1){ // La dernière case du tableau est toujours "null" car c'est la casse de victoire
                tableau[i] = null;
            }else{
                // on choisit aléatoirement un chiffre (1 ou 0)
                Random random = new Random();
                int choix = random.nextInt(2);
                if(choix == 0){ // si c'est 0 alors on ne place pas de méchant sur cette case du tableau
                    tableau[i] = null;
                } else { // si c'est 1 alors on choisit aléatoirement le méchant qui sera placé dans le tableau
                    int choixMechant = random.nextInt(4); // Génère entre 0 et 3
                    tableau[i] = mechants.get(choixMechant); // On place le méchant choisi dans le tableau
                }
            }
        }
        return tableau;
    }
    // Lancement d'un tour de jeu
    public static void LancementTour(Personnage[] tableau, Gentil gentil, Context context){
        System.out.println("\nLancement de tour");
        context.AfficheTableau(tableau);
        // Calcul position Gentil dans le tableau
        int positionGentil = -1;
        for (int i = 0; i < tableau.length; i++){
            if(tableau[i] == null){
            } else if (tableau[i].getNom() == gentil.getNom()){
                positionGentil = i;
            }
        }
        if (tableau[positionGentil + 1] !=null){ // Si il y a un méchant sur la case devant le gentil
            Mechant mechantTest = (Mechant) tableau[positionGentil + 1];
            if (mechantTest.getType() == TypeMechant.GANGSTER) { // on regarde si c'est un méchant de type Gangster
                // Si c'est un gangster alors le méchant attaque une première fois avant le gentil
                mechantTest.attaquer(gentil);
            }
        }

        // Si le gentil a sa capacite on demande a l'utilisateur s'il souhaite l'utiliser
        int choixCapacite = - 1;
        Scanner scanner = new Scanner(System.in);
        if (gentil.getCapaciteSpeciale() != null){
            while (choixCapacite < 1 || choixCapacite > 2)
            {
                System.out.print("\nSouhaitez-vous utiliser la capacité spéciale ?\n" +
                        "1 NON\n" +
                        "2 OUI\n");
                if (scanner.hasNextInt()) {
                    choixCapacite = scanner.nextInt();
                    if (choixCapacite < 1 || choixCapacite > 2) {
                        System.out.println("Numéro invalide. Veuillez réessayer.");
                    }
                } else {
                    System.out.println("Entrée invalide. Veuillez entrer 1 ou 2.");
                    scanner.next(); // Nettoyer l'entrée invalide
                }
            }
            if(choixCapacite == 2){
                // On utilise la capacité spéciale
                MyLogger.getInstance().log("Le joueur a choisi d'utiliser la capacité spéciale :"+ gentil.getCapaciteSpeciale().getNom());
                gentil.utiliserPouvoir(tableau[positionGentil+1]);
                // le gentil n'a plus de capacité spéciale
            }
        }
        // Si la case devant le gentil est occupé par un mechant
        if(tableau[positionGentil+1] != null){
            // Attaque du gentil puis riposte de méchant
            Mechant mechant = (Mechant) tableau[positionGentil+1];
            Random random = new Random();
            int nombreAttaque = random.nextInt(5); // le gentil attaque un nombre de fois aléatoire entre 1 fois et 5 fois
            // le gentil attaque 1 fois en premier
            gentil.attaquer(mechant);
            if(mechant.getIsAlive() && (mechant.getType() != TypeMechant.GANGSTER)){
                // si le méchant est en vie et que ce n'est pas un gangster alors il attaque le gentil
                mechant.attaquer(gentil);
            }
            if (!gentil.getIsAlive()){ // Si le gentil est mort, on affiche que le méchant l'a tué
                System.out.println("Le méchant "+ mechant.getNom()+" a tué le gentil "+ gentil.getNom());
            }else{ // Si le gentil est en vie et que le méchant aussi, il attaque le méchant
                for (int i = 0; i < nombreAttaque; i++) {
                    if(mechant.getIsAlive()){
                        gentil.attaquer(mechant);
                    }
                }
                if(mechant.getIsAlive()){ // Si le méchant est coriace et qu'il est encore en vie
                    tableau[positionGentil+1] = mechant;
                }else{ // Si le méchant est mort le gentil avance
                    tableau = AvancerGentil(tableau, gentil);
                }
            }

        }else{
            // On fait avancer le gentil d'une case s'il n'y a rien
            tableau = AvancerGentil(tableau, gentil);

        }
    }
    // Fait avancer le gentil sur la case suivante
    public static Personnage[] AvancerGentil(Personnage[] tableau, Gentil gentil){
        // Calcul position Gentil dans le tableau
        int positionGentil = -1;
        for (int i = 0; i < tableau.length; i++){
            if(tableau[i] == null){
            } else if (tableau[i].getNom() == gentil.getNom()){
                positionGentil = i;
            }
        }
        // On place le gentil sur la case suivante
        tableau[positionGentil+1] = gentil;
        // On supprime le gentil de la case précédente
        tableau[positionGentil]=null;
        MyLogger.getInstance().log(gentil.getNom()+" a avancé d'une case.");
        MyLogger.getInstance().log(Context.toStringTableau(tableau));
        return tableau;
    }
    // Permet d'afficher le tableau de jeu
    public static void AfficheTableau(Personnage[] tableau){
        for (int i = 0; i < tableau.length ; i++) {
            if (tableau[i] != null) {
                // Si la case du tableau est différente de "null" alors on affiche le symbole du personnage
                System.out.print(tableau[i].getSymbole());
            } else if (i == tableau.length - 1) {
                // on affiche toujours un 0 sur la dernière case du tableau pour signaliser l'arrivée de la map
                System.out.print("0");
            }else {
                // Si aucun personnage n'est sur la case on met un "_"
                System.out.print("_");
            }
        }
        System.out.println();
    }
    // Choix du gentil par l'utilisateur
    public static Gentil ChoixGentil(List<Gentil> gentils){
        Scanner scanner = new Scanner(System.in);
        int indice = 1;
        System.out.println("");
        for (Gentil gentil : gentils) {
            System.out.println(indice + " - "+  gentil.getNom() +
                    ", pv = " + gentil.getPv() +
                    ", pa = " + gentil.getPa() +
                    ", defense = " + gentil.getDefense() +
                    ", capaciteSpeciale = " + gentil.getCapaciteSpeciale().getNom());
            indice ++;
        }
        int choix = -1;
        while (choix < 1 || choix > gentils.size()) {
            // L'utilisateur choisi un gentil parmis la liste de gentils proposé
            System.out.print("Veuillez choisir un gentil en entrant son numéro (1-" + gentils.size() + ") : ");
            if (scanner.hasNextInt()) {
                choix = scanner.nextInt();
                if (choix < 1 || choix > gentils.size()) {
                    System.out.println("Numéro invalide. Veuillez réessayer.");
                }
            } else {
                System.out.println("Entrée invalide. Veuillez entrer un numéro.");
                scanner.next(); // Nettoyer l'entrée invalide
            }
        }
        Gentil gentilChoisi = gentils.get(choix - 1);
        return gentilChoisi;
    }
    // Choix de la carte de jeu par l'utilisateur
    public static Carte ChoixCarte(List<Carte> cartes){
        Scanner scanner = new Scanner(System.in);
        int indice = 1;
        for (Carte carte : cartes) {
            System.out.println(indice + " - "+ carte.getNom());
            indice ++;
        }
        int choix = -1;
        while (choix < 1 || choix > cartes.size()){
            // L'utilisateur choisi une carte parmis la liste de carte possible
            System.out.print("Veuillez choisir une carte en entrant son numéro (1 - " + cartes.size() + ") : ");
            if (scanner.hasNextInt()) {
                choix = scanner.nextInt();
                if (choix < 1 || choix > cartes.size()) {
                    System.out.println("Numéro invalide. Veuillez réessayer.");
                }
            } else {
                System.out.println("Entrée invalide. Veuillez entrer un numéro.");
                scanner.next(); // Nettoyer l'entrée invalide
            }
        }
        Carte cartechoisie = cartes.get(choix - 1);
        return cartechoisie;
    }
    // Création de la liste des cartes disponibles
    public static List<Carte> CreationCartes(){
        List<Carte> cartes = new ArrayList<>();
        Carte facile = new Carte("France", "Facile", 0, 4, 5);
        Carte moyenne = new Carte("Espagne", "Moyenne", 0, 6, 7);
        Carte difficile = new Carte("Italie", "Difficile", 0, 8, 9);
        Carte extreme = new Carte("Allemagne", "Extreme", 0, 10, 11);
        cartes.add(facile);
        cartes.add(moyenne);
        cartes.add(difficile);
        cartes.add(extreme);
        return cartes;
    }
    // Création de la liste des gentils disponibles
    public static List<Gentil> CreationGentils(){
        List<Gentil> gentils = new ArrayList<>();
        Gentil flash = new Gentil('*', 4, 20, 30,"Flash Gordon", CapaciteSpeciale.MULTI_SHOT);
        Gentil saitama = new Gentil('*', 6, 30, 25,"Saitama", CapaciteSpeciale.ONE_SHOT);
        Gentil moira = new Gentil('*', 2, 20, 40,"Moïra", CapaciteSpeciale.MULTI_SHOT);
        gentils.add(flash);
        gentils.add(saitama);
        gentils.add(moira);
        return gentils;
    }
    // Création de la liste des méchants disponibles
    public static List<Mechant> CreationMechants(){
        List<Mechant> mechants = new ArrayList<>();
        Mechant catcheur = new Mechant('!', "Catcheur", TypeMechant.CATCHEUR);
        Mechant brute = new Mechant('!', "Brute", TypeMechant.BRUTE);
        Mechant tireur = new Mechant('!', "Tireur", TypeMechant.TIREUR);
        Mechant gangster = new Mechant('!', "Gangster", TypeMechant.GANGSTER);
        Mechant boss = new Mechant('$', "Boss", TypeMechant.BOSS);
        mechants.add(catcheur);
        mechants.add(brute);
        mechants.add(tireur);
        mechants.add(gangster);
        mechants.add(boss);
        return mechants;
    }

    // Lancement automatique du tour (utilisé pour les tests unitaires)
    public static void LancementTourAutomatique(Personnage[] tableau, Gentil gentil, Context context){
        // Calcul position Gentil dans le tableau
        System.out.println("\nLancement de tour");
        context.AfficheTableau(tableau);
        int positionGentil = -1;
        for (int i = 0; i < tableau.length; i++){
            if(tableau[i] == null){
            } else if (tableau[i].getNom() == gentil.getNom()){
                positionGentil = i;
            }
        }
        // Si la case devant le gentil est occupé par un mechant
        if(tableau[positionGentil+1] != null){
            // Attaque du heros puis riposte mechant
            Mechant mechant = (Mechant) tableau[positionGentil+1];
            Random random = new Random();
            int nombreAttaque = random.nextInt(5); // Entre 1 et 5 attaques
            gentil.attaquer(mechant);

            if(mechant.getIsAlive()){
                mechant.attaquer(gentil);
            }
            if (!gentil.getIsAlive()){
                System.out.println("Le méchant "+ mechant.getNom()+" a tué le gentil "+ gentil.getNom());
            }else{
                for (int i = 0; i < nombreAttaque; i++) {
                    if(mechant.getIsAlive()){
                        gentil.attaquer(mechant);
                    }
                }
                if(mechant.getIsAlive()){
                    tableau[positionGentil+1] = mechant;
                }else{
                    tableau = AvancerGentil(tableau, gentil);
                }
            }
        }else{
            // On fait avancer le gentil d'une case s'il n'y a rien
            tableau = AvancerGentil(tableau, gentil);
        }
        context.AfficheTableau(tableau);
    }
    // Permet d'afficher lee tableau dans le fichier de log
    public static String toStringTableau(Personnage[] tableau){
        String tableauString = "";
        for (int i = 0; i < tableau.length ; i++) {
            if (tableau[i] != null) {
                tableauString +=tableau[i].getSymbole();
            } else if (i == tableau.length - 1) {
                tableauString += '0';
            }else {
                tableauString += '_';
            }
        }
        return tableauString;
    }
}
