// _________ .__                              ____.
// \_   ___ \|  | _____    ______ ______     |    | ____  __ __
// /    \  \/|  | \__  \  /  ___//  ___/     |    _/ __ \|  |  \
// \     \___|  |__/ __ \_\___ \ \___ \  /\__|    \  ___/|  |  /
//  \______  |____(____  /____  /____  > \________|\___  |____/
//         \/          \/     \/     \/                \/
package Entity;

import java.util.List;

public class Jeu {
    //Définition des caractéristiques d'un objet jeu
    private Carte carte; // choix d'une carte dans une liste
    private Gentil gentil; // choix d'un gentil dans une liste
    private List<Mechant> mechants ; // liste de méchants choisis aléatoirement
    private Personnage[] tableau; // le tableau montrant le déroulement du jeu

    //Définition du constructeur
    public Jeu(Carte carte, Gentil gentil, List<Mechant> mechants, Personnage[] tableau) {
        this.carte = carte;
        this.gentil = gentil;
        this.mechants = mechants;
        this.tableau = tableau;
    }
    //Définition des Getters et Setters
    //Getter et Setter de la carte choisi
    public Carte getCarte() {
        return carte;
    }
    public void setCarte(Carte carte) {
        this.carte = carte;
    }
    //Getter et Setter du gentil choisi
    public Gentil getGentil() {
        return gentil;
    }
    public void setGentil(Gentil gentil) {
        this.gentil = gentil;
    }
    //Getter et Setter de la liste de mechant
    public List<Mechant> getMechants() {
        return mechants;
    }
    public void setMechants(List<Mechant> mechants) {
        this.mechants = mechants;
    }
    //Getter et Setter du tableau
    public Personnage[] getTableau() {
        return tableau;
    }
    public void setTableau(Personnage[] tableau) {
        this.tableau = tableau;
    }
}
