// _________ .__                         __________
// \_   ___ \|  | _____    ______ ______ \______   \ ___________ __________   ____   ____ _____    ____   ____
// /    \  \/|  | \__  \  /  ___//  ___/  |     ____/ __ \_  __ /  ___/  _ \ /    \ /    \\__  \  / ___\_/ __ \
// \     \___|  |__/ __ \_\___ \ \___ \   |    |   \  ___/|  | \\___ (  <_> |   |  |   |  \/ __ \/ /_/  \  ___/
//  \______  |____(____  /____  /____  >  |____|    \___  |__| /____  \____/|___|  |___|  (____  \___  / \___  >
//         \/          \/     \/     \/                 \/          \/           \/     \/     \/_____/      \/
package Entity;
// Création de la classe Personnage
public class Personnage {
    // Définition des différentes caractéristiques d'un personnage
    private String nom;
    private int pv; // Points de vie
    private int pa; // Points d'attaque
    private int defense; // Point de défense
    private char symbole; // charactère pour afficher le personnage dans le Jeu.tableau
    private boolean isAlive; // vrai si le personnage est en vi
    // Définition du constructeur
    public Personnage(char symbole, int defense, int pa, int pv, String nom) {
        this.symbole = symbole;
        this.defense = defense;
        this.pa = pa;
        if( 0< pv  && pv < 51){
            this.pv = pv;
        }else{
            throw new IllegalArgumentException("Les PV de base doivent être compris entre 10 et 50");
        }
        this.nom = nom;
        this.isAlive = true;
    }
    // Fonction qui permet de retourner si un personnage est en vie ou non
    public boolean getIsAlive() {
        return isAlive;
    }
    // Définition de la variable isAlive en fonction de l'état du personnage
    public void setIsAlive(boolean alive) {
        isAlive = alive;
    }
    //Fonction qui permet de retourner le symbole du personnage
    public char getSymbole() {
        return symbole;
    }
    // Définition du symbole qui correspond au personnage
    public void setSymbole(char symbole) {
        this.symbole = symbole;
    }
    // Fonction qui permet de retourner les points de défense d'un personnage
    public int getDefense() {
        return defense;
    }
    // Définition des points de défense d'un personnage
    public void setDefense(int defense) {
        this.defense = defense;
    }
    // Fonction qui permet de retourner les points d'attaque d'un personnage
    public int getPa() {
        return pa;
    }
    // Définition des points d'attaque d'un personnage
    public void setPa(int pa) {
        this.pa = pa;
    }
    // Fonction qui permet de retourner les points de vie d'un personnage
    public int getPv() {
        return pv;
    }
    // Définition des points de vie d'un personnage
    public void setPv(int pv) {
        this.pv = pv;
        if(pv <= 0){
            this.setIsAlive(false);
            this.pv = 0;
            System.out.println(this.getNom()+" est mort");
            MyLogger.getInstance().log(this.getNom()+" est mort");
        }
    }
    // Fonction qui permet de retourner le nom d'un personnage
    public String getNom() {
        return nom;
    }
    // Définition du nom du personnage
    public void setNom(String nom) {
        this.nom = nom;
    }
    // Permet de pouvoir afficher les caractéristiques d'un personnage dans le terminal
    @Override
    public String toString() {
        return "Personnage{" +
                "nom='" + nom + '\'' +
                ", pv=" + pv +
                ", pa=" + pa +
                ", defense=" + defense +
                ", symbole=" + symbole +
                '}';
    }
}
