// ___________                      ___________                      _____               .__                   __
// \_   _____/ ____  __ __  _____   \__    ______.________   ____   /     \   ____  ____ |  |__ _____    _____/  |_
//  |    __)_ /    \|  |  \/     \    |    | <   |  \____ \_/ __ \ /  \ /  \_/ __ _/ ___\|  |  \\__  \  /    \   __\
//  |        |   |  |  |  |  Y Y  \   |    |  \___  |  |_> \  ___//    Y    \  ___\  \___|   Y  \/ __ \|   |  |  |
// /_______  |___|  |____/|__|_|  /   |____|  / ____|   __/ \___  \____|__  /\___  \___  |___|  (____  |___|  |__|
//         \/     \/            \/            \/    |__|        \/        \/     \/    \/     \/     \/     \/
package Enum;
// Création de l'enum TypeMechant
public enum TypeMechant {
    // Définition des différents types de méchants du jeu
    CATCHEUR ("Catcheur",10,7,3),
    GANGSTER ("Gangster",5, 9, 2),
    BRUTE("Brute",15, 8, 4),
    TIREUR("Tireur",2, 12, 1),
    BOSS("BOSS", 17,11,5);
    // Définition des différentes caractéristiques du type de méchant
    private final int bonusPv; // points de vie de base du type de méchant
    private final int bonusPa; // points d'attaque de base du type de méchant
    private final int bonusDefense; // défense de base du type de méchant
    private final String nom; // nom du type de méchant
    // Définition du constructeur
    TypeMechant(String nom, int bonusPv, int bonusPa, int bonusDefense) {
        this.bonusPv = bonusPv;
        this.bonusPa = bonusPa;
        this.bonusDefense = bonusDefense;
        this.nom = nom;
    }
    // Fonction qui permet de retourner les points d'attaque du type de méchant
    public int getBonusPa() {
        return bonusPa;
    }
    // Fonction qui permet de retourner les points de vie du type de méchant
    public int getBonusPv() {
        return bonusPv;
    }
    // Fonction qui permet de retourner les points de défense du type de méchant
    public int getBonusDefense() {
        return bonusDefense;
    }
    // Fonction qui permet de retourner le nom du type de méchant
    public String getNom() {
        return nom;
    }
}
