// _________ .__                            _____               .__                   __
// \_   ___ \|  | _____    ______ ______   /     \   ____  ____ |  |__ _____    _____/  |_
// /    \  \/|  | \__  \  /  ___//  ___/  /  \ /  \_/ __ _/ ___\|  |  \\__  \  /    \   __\
// \     \___|  |__/ __ \_\___ \ \___ \  /    Y    \  ___\  \___|   Y  \/ __ \|   |  |  |
//  \______  |____(____  /____  /____  > \____|__  /\___  \___  |___|  (____  |___|  |__|
//         \/          \/     \/     \/          \/     \/    \/     \/     \/     \/
package Entity;

import Interfaces.ActionPersonnage;
import Enum.TypeMechant;
// Création de la classe Mechant qui est enfant de la classe Personnage et qui utilise l'interface ActionPersonnage
public class Mechant extends Personnage implements ActionPersonnage {
    // Définition des différentes caractéristiques d'un méchant
    TypeMechant type;
    public Mechant(char symbole, String nom, TypeMechant type) {
        super(symbole, type.getBonusDefense(), type.getBonusPa(), type.getBonusPv(), nom); // les pv d'un méchant sont issus de son type 
        this.type = type;
    }
    public TypeMechant getType() {
        return type;
    }
    public void setType(TypeMechant type) {
        this.type = type;
    }
    // Permet de pouvoir afficher les caractéristiques d'un méchant dans le terminal
    @Override
    public String toString() {
        return "Mechant de type "+ this.getType().getNom()+"{" +
                "nom='" + this.getNom() + '\'' +
                ", pv=" + this.getPv() +
                ", pa=" + this.getPa() +
                ", defense=" + this.getDefense() +
                ", symbole=" + this.getSymbole() +
                '}';
    }
    // Fonction qui permet à un personnage (méchant) d'attaquer sa cible (gentil) et de lui infliger des dégats
    @Override
    public void attaquer(Personnage cible) {
        int degats = this.getPa() - cible.getDefense();
        if (degats < 0) {degats = 0;}
        System.out.println(this.getNom() +" à attaqué " + cible.getNom() + " et lui a infligé " + degats + " points de dégats");
        MyLogger.getInstance().log(this.getNom() +" à attaqué " + cible.getNom() + " et lui a infligé " + degats + " points de dégats");
        cible.setPv(cible.getPv() - degats);
    }
    // Fonction qui informe qu'un méchant n'a pas de capacité spéciale
    @Override
    public void utiliserPouvoir(Personnage cible) {
        System.out.println("Les méchants n'ont pas de pouvoir !!");
    }
}
