// _________ .__                            _____        .____
// \_   ___ \|  | _____    ______ ______   /     \ ___.__|    |    ____   ____   ____   ___________
// /    \  \/|  | \__  \  /  ___//  ___/  /  \ /  <   |  |    |   /  _ \ / ___\ / ___\_/ __ \_  __ \
// \     \___|  |__/ __ \_\___ \ \___ \  /    Y    \___  |    |__(  <_> / /_/  / /_/  \  ___/|  | \/
//  \______  |____(____  /____  /____  > \____|__  / ____|_______ \____/\___  /\___  / \___  |__|
//         \/          \/     \/     \/          \/\/            \/    /_____//_____/      \/
package Entity;

import java.io.FileWriter;
import java.io.IOException;
import java.time.LocalDateTime;
// Création de la classe MyLogger qui permet de créer le fichier de log
public class MyLogger {
    private static MyLogger instance;
    private FileWriter writer;

    private MyLogger() {
        try {
            writer = new FileWriter("IMfighTer.log", true);
        } catch (IOException e) {
            System.out.println("Erreur lors de l'initialisation du logger : " + e.getMessage());
        }
    }

    public static MyLogger getInstance() {
        if (instance == null) {
            instance = new MyLogger();
        }
        return instance;
    }

    public void log(String message) {
        try {
            String timestamp = "[" + LocalDateTime.now() + "] ";
            writer.write(timestamp + message + "\n");
            writer.flush();
        } catch (IOException e) {
            System.out.println("Erreur lors de l'écriture dans le fichier de log : " + e.getMessage());
        }
    }
}