// ___________                      _________                            .__  __           _________                   .__       .__
// \_   _____/ ____  __ __  _____   \_   ___ \_____  ___________    ____ |___/  |_  ____  /   ___________   ____  ____ |_______  |  |   ____
//  |    __)_ /    \|  |  \/     \  /    \  \/\__  \ \____ \__  \ _/ ___\|  \   ___/ __ \ \_____  \\____ \_/ __ _/ ___\|  \__  \ |  | _/ __ \
//  |        |   |  |  |  |  Y Y  \ \     \____/ __ \|  |_> / __ \\  \___|  ||  | \  ___/ /        |  |_> \  ___\  \___|  |/ __ \|  |_\  ___/
// /_______  |___|  |____/|__|_|  /  \______  (____  |   __(____  /\___  |__||__|  \___  /_______  |   __/ \___  \___  |__(____  |____/\___  >
//         \/     \/            \/          \/     \/|__|       \/     \/              \/        \/|__|        \/    \/        \/          \/
package Enum;
// Création de l'enum CapaciteSpeciale
public enum CapaciteSpeciale {
    // Définition des différentes capacité spéciale du jeu
    SOIN("Soin", 25, true),
    ONE_SHOT("One Shot", 100, false),
    MULTI_SHOT("Multi shot", 0, false),
    TREMPETTE("Trempette", 0, false ),
    GONFLETTE("Gonflette", 25, false );
    // Définition des différentes caractéristiques des capacités spéciales
    private final String nom; // Nom de la capacité spéciale
    private final int effet; // Points à ajouter (soin) ou à infliger (attaque)
    private final boolean estSoins; // Vrai si c'est une capacité de soin, faux sinon
    // Définition du constructeur
    CapaciteSpeciale(String nom, int effet, boolean estSoins) {
        this.nom = nom;
        this.effet = effet;
        this.estSoins = estSoins;
    }
    // Fonction qui permet de retourner le nom de la capacité spéciale
    public String getNom() {
        return nom;
    }
    // Fonction qui permet de retourner les effets de la capacité spéciale
    public int getEffet() {
        return effet;
    }
    // Fonction qui permet de retourner si la capacité spéciale permet de soigné ou non
    public boolean estSoins() {
        return estSoins;
    }
}
